﻿'--------------------------------------------------------------------------------------------------------
'                                         HOMESEER WATCHDOG
'         by DJF3, based on code by Jon00 - http://www.domoticaworld.com - info@domoticaworld.com
' version 0.1 - Dec 08 2010
'		First try
' HOW?	Checks if it can access the HS web interface. If not it will retry and then restart HS
' SETUP	Place Jon00RestartHS.exe in HS folder. Setup 3 parameters below. Create event to run this every x minutes
'--------------------------------------------------------------------------------------------------------
Sub Main(ByVal Parm As Object)

Dim Port As String = hs.GetINISetting("Settings","svrport","","Settings.ini")
'DJ: strDebug 0=no debugging, 1=debugging
Dim strDebug as Integer = 0
'DJ: strRestart 0=no restart but run Event 'strReportEvent', 1=Restart HS using Jon00RestartHS.exe
Dim strRestart as Integer = 0
'DJ: strReportEvent=event name that should be run if not restarting HS.
Dim strReportEvent as String = "HomeSeer ERROR"
Dim URLPath="http://Localhost"
Dim URLPathLoc As String = "/evls"
Dim Result As String = hs.GetURL(URLPath,URLPathLoc,True,Port)
If strDebug > 0 then hs.writelog ("SYSTEM","<b><font color=orange>Running HomeSeer watchdog...</font></b>")


If Result.Length < 100 then
    hs.writelog ("SYSTEM","<b>ERROR !</b> Cannot access Homeseer's Web server - trying again...")
    URLPathLoc = "/stat"
else
    If strDebug > 0 then hs.writelog ("Watchdog","Success in reading Homeseer's events page")
    Exit sub
end if

hs.waitsecs (60)

'DJ: 2nd try to see if it works after x seconds, otherwise restart HS
Result = hs.GetURL(URLPath,URLPathLoc,True,Port)
If Result.Length < 100 then
    hs.writelog ("SYSTEM","<b>ERROR !</b> Cannot access Homeseer's Web Server - restarting Homeseer")
    If strRestart > 0 then hs.launch ("Jon00RestartHS.exe")
	If strRestart = 0 and strReportEvent <> "" then hs.triggerevent(strReportEvent)
        If strrestart = 0 and strReportEvent <> "" then hs.triggerevent("Events Check")
else
    If strDebug > 0 then hs.writelog ("Watchdog","Success in reading Homeseer's status page")
end if
end sub  